diff --git a/NetworkPkg/UefiPxeBcDxe/PxeBcDhcp6.c b/NetworkPkg/UefiPxeBcDxe/PxeBcDhcp6.c
index 8d71143..425e0cf 100644
--- a/NetworkPkg/UefiPxeBcDxe/PxeBcDhcp6.c
+++ b/NetworkPkg/UefiPxeBcDxe/PxeBcDhcp6.c
@@ -1229,43 +1236,40 @@ PxeBcSelectDhcp6Offer (
       // 1. DhcpPxe10 offer
       //
       Private->SelectIndex = Private->OfferIndex[PxeOfferTypeDhcpPxe10][0] + 1;
-
     } else if (Private->OfferCount[PxeOfferTypeDhcpWfm11a] > 0) {
       //
       // 2. DhcpWfm11a offer
       //
       Private->SelectIndex = Private->OfferIndex[PxeOfferTypeDhcpWfm11a][0] + 1;
-
-    } else if (Private->OfferCount[PxeOfferTypeDhcpOnly] > 0 &&
-               Private->OfferCount[PxeOfferTypeProxyPxe10] > 0) {
+    } else if ((Private->OfferCount[PxeOfferTypeDhcpOnly] > 0) &&
+               (Private->OfferCount[PxeOfferTypeProxyPxe10] > 0))
+    {
       //
       // 3. DhcpOnly offer and ProxyPxe10 offer.
       //
       Private->SelectIndex     = Private->OfferIndex[PxeOfferTypeDhcpOnly][0] + 1;
       Private->SelectProxyType = PxeOfferTypeProxyPxe10;
-
-    } else if (Private->OfferCount[PxeOfferTypeDhcpOnly] > 0 &&
-               Private->OfferCount[PxeOfferTypeProxyWfm11a] > 0) {
+    } else if ((Private->OfferCount[PxeOfferTypeDhcpOnly] > 0) &&
+               (Private->OfferCount[PxeOfferTypeProxyWfm11a] > 0))
+    {
       //
       // 4. DhcpOnly offer and ProxyWfm11a offer.
       //
       Private->SelectIndex     = Private->OfferIndex[PxeOfferTypeDhcpOnly][0] + 1;
       Private->SelectProxyType = PxeOfferTypeProxyWfm11a;
-
     } else if (Private->OfferCount[PxeOfferTypeDhcpBinl] > 0) {
       //
       // 5. DhcpBinl offer.
       //
       Private->SelectIndex = Private->OfferIndex[PxeOfferTypeDhcpBinl][0] + 1;
-
-    } else if (Private->OfferCount[PxeOfferTypeDhcpOnly] > 0 &&
-               Private->OfferCount[PxeOfferTypeProxyBinl] > 0) {
+    } else if ((Private->OfferCount[PxeOfferTypeDhcpOnly] > 0) &&
+               (Private->OfferCount[PxeOfferTypeProxyBinl] > 0))
+    {
       //
       // 6. DhcpOnly offer and ProxyBinl offer.
       //
       Private->SelectIndex     = Private->OfferIndex[PxeOfferTypeDhcpOnly][0] + 1;
       Private->SelectProxyType = PxeOfferTypeProxyBinl;
-
     } else {
       //
       // 7. DhcpOnly offer with bootfilename.
@@ -1283,7 +1287,6 @@ PxeBcSelectDhcp6Offer (
     // Select offer by received order.
     //
     for (Index = 0; Index < Private->OfferNum; Index++) {
-
       OfferType = Private->OfferBuffer[Index].Dhcp6.OfferType;
 
       if (IS_PROXY_OFFER (OfferType)) {
@@ -1294,8 +1297,9 @@ PxeBcSelectDhcp6Offer (
       }
 
       if (!Private->IsProxyRecved &&
-          OfferType == PxeOfferTypeDhcpOnly &&
-          Private->OfferBuffer[Index].Dhcp6.OptList[PXEBC_DHCP6_IDX_BOOT_FILE_URL] == NULL) {
+          (OfferType == PxeOfferTypeDhcpOnly) &&
+          (Private->OfferBuffer[Index].Dhcp6.OptList[PXEBC_DHCP6_IDX_BOOT_FILE_URL] == NULL))
+      {
         //
         // Skip if DhcpOnly offer without any other proxy offers or bootfilename.
         //
@@ -1308,7 +1312,6 @@ PxeBcSelectDhcp6Offer (
   }
 }
 
-
 /**
   Handle the DHCPv6 offer packet.
 
@@ -1322,21 +1325,21 @@ PxeBcSelectDhcp6Offer (
 **/
 EFI_STATUS
 PxeBcHandleDhcp6Offer (
-  IN PXEBC_PRIVATE_DATA            *Private
+  IN PXEBC_PRIVATE_DATA  *Private
   )
 {
-  PXEBC_DHCP6_PACKET_CACHE         *Cache6;
-  EFI_STATUS                       Status;
-  PXEBC_OFFER_TYPE                 OfferType;
-  UINT32                           ProxyIndex;
-  UINT32                           SelectIndex;
-  UINT32                           Index;
+  PXEBC_DHCP6_PACKET_CACHE  *Cache6;
+  EFI_STATUS                Status;
+  PXEBC_OFFER_TYPE          OfferType;
+  UINT32                    ProxyIndex;
+  UINT32                    SelectIndex;
+  UINT32                    Index;
 
   ASSERT (Private->SelectIndex > 0);
-  SelectIndex = (UINT32) (Private->SelectIndex - 1);
+  SelectIndex = (UINT32)(Private->SelectIndex - 1);
   ASSERT (SelectIndex < PXEBC_OFFER_MAX_NUM);
-  Cache6      = &Private->OfferBuffer[SelectIndex].Dhcp6;
-  Status      = EFI_SUCCESS;
+  Cache6 = &Private->OfferBuffer[SelectIndex].Dhcp6;
+  Status = EFI_SUCCESS;
 
   //
   // First try to cache DNS server address if DHCP6 offer provides.
@@ -1346,6 +1349,7 @@ PxeBcHandleDhcp6Offer (
     if (Private->DnsServer == NULL) {
       return EFI_OUT_OF_RESOURCES;
     }
+
     CopyMem (Private->DnsServer, Cache6->OptList[PXEBC_DHCP6_IDX_DNS_SERVER]->Data, sizeof (EFI_IPv6_ADDRESS));
   }
 
@@ -1357,7 +1361,6 @@ PxeBcHandleDhcp6Offer (
       Status = EFI_NO_RESPONSE;
     }
   } else if (Cache6->OfferType == PxeOfferTypeDhcpOnly) {
-
     if (Private->IsProxyRecved) {
       //
       // DhcpOnly offer is selected, so need try to request bootfilename.
@@ -1375,12 +1378,12 @@ PxeBcHandleDhcp6Offer (
           // Try all the cached ProxyBinl offer one by one to request bootfilename.
           //
           for (Index = 0; Index < Private->OfferCount[Private->SelectProxyType]; Index++) {
-
             ProxyIndex = Private->OfferIndex[Private->SelectProxyType][Index];
             if (!EFI_ERROR (PxeBcRetryDhcp6Binl (Private, ProxyIndex))) {
               break;
             }
           }
+
           if (Index == Private->OfferCount[Private->SelectProxyType]) {
             Status = EFI_NO_RESPONSE;
           }
@@ -1397,7 +1400,6 @@ PxeBcHandleDhcp6Offer (
         Status = EFI_NO_RESPONSE;
 
         for (Index = 0; Index < Private->OfferNum; Index++) {
-
           OfferType = Private->OfferBuffer[Index].Dhcp6.OfferType;
 
           if (!IS_PROXY_OFFER (OfferType)) {
@@ -1423,7 +1425,7 @@ PxeBcHandleDhcp6Offer (
         }
       }
 
-      if (!EFI_ERROR (Status) && Private->SelectProxyType != PxeOfferTypeProxyBinl) {
+      if (!EFI_ERROR (Status) && (Private->SelectProxyType != PxeOfferTypeProxyBinl)) {
         //
         // Success to try to request by a ProxyPxe10 or ProxyWfm11a offer, copy and parse it.
         //
@@ -1441,14 +1443,13 @@ PxeBcHandleDhcp6Offer (
     //
     // All PXE boot information is ready by now.
     //
-    Status = PxeBcCopyDhcp6Ack (Private, &Private->DhcpAck.Dhcp6.Packet.Ack, TRUE);
+    Status                                 = PxeBcCopyDhcp6Ack (Private, &Private->DhcpAck.Dhcp6.Packet.Ack, TRUE);
     Private->PxeBc.Mode->DhcpDiscoverValid = TRUE;
   }
 
   return Status;
 }
 
-
 /**
   Unregister the address by Ip6Config protocol.
 
@@ -1457,7 +1458,7 @@ PxeBcHandleDhcp6Offer (
 **/
 VOID
 PxeBcUnregisterIp6Address (
-  IN PXEBC_PRIVATE_DATA           *Private
+  IN PXEBC_PRIVATE_DATA  *Private
   )
 {
   if (Private->Ip6Policy != PXEBC_IP6_POLICY_MAX) {
@@ -1485,18 +1486,18 @@ PxeBcUnregisterIp6Address (
 **/
 EFI_STATUS
 PxeBcCheckRouteTable (
-  IN  PXEBC_PRIVATE_DATA            *Private,
-  IN  UINTN                         TimeOutInSecond,
-  OUT EFI_IPv6_ADDRESS              *GatewayAddr
+  IN  PXEBC_PRIVATE_DATA  *Private,
+  IN  UINTN               TimeOutInSecond,
+  OUT EFI_IPv6_ADDRESS    *GatewayAddr
   )
 {
-  EFI_STATUS                       Status;
-  EFI_IP6_PROTOCOL                 *Ip6;
-  EFI_IP6_MODE_DATA                Ip6ModeData;
-  UINTN                            Index;
-  EFI_EVENT                        TimeOutEvt;
-  UINTN                            RetryCount;
-  BOOLEAN                          GatewayIsFound;
+  EFI_STATUS         Status;
+  EFI_IP6_PROTOCOL   *Ip6;
+  EFI_IP6_MODE_DATA  Ip6ModeData;
+  UINTN              Index;
+  EFI_EVENT          TimeOutEvt;
+  UINTN              RetryCount;
+  BOOLEAN            GatewayIsFound;
 
   ASSERT (GatewayAddr != NULL);
   ASSERT (Private != NULL);
@@ -1527,23 +1528,28 @@ PxeBcCheckRouteTable (
     if (Ip6ModeData.AddressList != NULL) {
       FreePool (Ip6ModeData.AddressList);
     }
+
     if (Ip6ModeData.GroupTable != NULL) {
       FreePool (Ip6ModeData.GroupTable);
     }
+
     if (Ip6ModeData.RouteTable != NULL) {
       FreePool (Ip6ModeData.RouteTable);
     }
+
     if (Ip6ModeData.NeighborCache != NULL) {
       FreePool (Ip6ModeData.NeighborCache);
     }
+
     if (Ip6ModeData.PrefixTable != NULL) {
       FreePool (Ip6ModeData.PrefixTable);
     }
+
     if (Ip6ModeData.IcmpTypeList != NULL) {
       FreePool (Ip6ModeData.IcmpTypeList);
     }
 
-    if (GatewayIsFound || RetryCount == TimeOutInSecond) {
+    if (GatewayIsFound || (RetryCount == TimeOutInSecond)) {
       break;
     }
 
@@ -1569,6 +1575,7 @@ PxeBcCheckRouteTable (
     if (EFI_ERROR (Status)) {
       goto ON_EXIT;
     }
+
     while (EFI_ERROR (gBS->CheckEvent (TimeOutEvt))) {
       Ip6->Poll (Ip6);
     }
@@ -1600,29 +1607,29 @@ ON_EXIT:
 **/
 EFI_STATUS
 PxeBcRegisterIp6Address (
-  IN PXEBC_PRIVATE_DATA            *Private,
-  IN EFI_IPv6_ADDRESS              *Address
+  IN PXEBC_PRIVATE_DATA  *Private,
+  IN EFI_IPv6_ADDRESS    *Address
   )
 {
-  EFI_IP6_PROTOCOL                 *Ip6;
-  EFI_IP6_CONFIG_PROTOCOL          *Ip6Cfg;
-  EFI_IP6_CONFIG_POLICY            Policy;
-  EFI_IP6_CONFIG_MANUAL_ADDRESS    CfgAddr;
-  EFI_IPv6_ADDRESS                 GatewayAddr;
-  UINTN                            DataSize;
-  EFI_EVENT                        MappedEvt;
-  EFI_STATUS                       Status;
-  BOOLEAN                          NoGateway;
-  EFI_IPv6_ADDRESS                 *Ip6Addr;
-  UINTN                            Index;
-
-  Status     = EFI_SUCCESS;
-  MappedEvt  = NULL;
-  Ip6Addr    = NULL;
-  DataSize   = sizeof (EFI_IP6_CONFIG_POLICY);
-  Ip6Cfg     = Private->Ip6Cfg;
-  Ip6        = Private->Ip6;
-  NoGateway  = FALSE;
+  EFI_IP6_PROTOCOL               *Ip6;
+  EFI_IP6_CONFIG_PROTOCOL        *Ip6Cfg;
+  EFI_IP6_CONFIG_POLICY          Policy;
+  EFI_IP6_CONFIG_MANUAL_ADDRESS  CfgAddr;
+  EFI_IPv6_ADDRESS               GatewayAddr;
+  UINTN                          DataSize;
+  EFI_EVENT                      MappedEvt;
+  EFI_STATUS                     Status;
+  BOOLEAN                        NoGateway;
+  EFI_IPv6_ADDRESS               *Ip6Addr;
+  UINTN                          Index;
+
+  Status    = EFI_SUCCESS;
+  MappedEvt = NULL;
+  Ip6Addr   = NULL;
+  DataSize  = sizeof (EFI_IP6_CONFIG_POLICY);
+  Ip6Cfg    = Private->Ip6Cfg;
+  Ip6       = Private->Ip6;
+  NoGateway = FALSE;
 
   ZeroMem (&CfgAddr, sizeof (EFI_IP6_CONFIG_MANUAL_ADDRESS));
   CopyMem (&CfgAddr.Address, Address, sizeof (EFI_IPv6_ADDRESS));
@@ -1648,7 +1655,7 @@ PxeBcRegisterIp6Address (
   Status = Ip6Cfg->SetData (
                      Ip6Cfg,
                      Ip6ConfigDataTypePolicy,
-                     sizeof(EFI_IP6_CONFIG_POLICY),
+                     sizeof (EFI_IP6_CONFIG_POLICY),
                      &Policy
                      );
   if (EFI_ERROR (Status)) {
@@ -1674,22 +1681,22 @@ PxeBcRegisterIp6Address (
   }
 
   Private->IsAddressOk = FALSE;
-  Status = Ip6Cfg->RegisterDataNotify (
-                     Ip6Cfg,
-                     Ip6ConfigDataTypeManualAddress,
-                     MappedEvt
-                     );
-  if (EFI_ERROR(Status)) {
+  Status               = Ip6Cfg->RegisterDataNotify (
+                                   Ip6Cfg,
+                                   Ip6ConfigDataTypeManualAddress,
+                                   MappedEvt
+                                   );
+  if (EFI_ERROR (Status)) {
     goto ON_EXIT;
   }
 
   Status = Ip6Cfg->SetData (
                      Ip6Cfg,
                      Ip6ConfigDataTypeManualAddress,
-                     sizeof(EFI_IP6_CONFIG_MANUAL_ADDRESS),
+                     sizeof (EFI_IP6_CONFIG_MANUAL_ADDRESS),
                      &CfgAddr
                      );
-  if (EFI_ERROR(Status) && Status != EFI_NOT_READY) {
+  if (EFI_ERROR (Status) && (Status != EFI_NOT_READY)) {
     goto ON_EXIT;
   } else if (Status == EFI_NOT_READY) {
     //
@@ -1698,17 +1705,18 @@ PxeBcRegisterIp6Address (
     while (!Private->IsAddressOk) {
       Ip6->Poll (Ip6);
     }
+
     //
     // Check whether the IP6 address setting is successed.
     //
     DataSize = 0;
-    Status = Ip6Cfg->GetData (
-                       Ip6Cfg,
-                       Ip6ConfigDataTypeManualAddress,
-                       &DataSize,
-                       NULL
-                       );
-    if (Status != EFI_BUFFER_TOO_SMALL || DataSize == 0) {
+    Status   = Ip6Cfg->GetData (
+                         Ip6Cfg,
+                         Ip6ConfigDataTypeManualAddress,
+                         &DataSize,
+                         NULL
+                         );
+    if ((Status != EFI_BUFFER_TOO_SMALL) || (DataSize == 0)) {
       Status = EFI_DEVICE_ERROR;
       goto ON_EXIT;
     }
@@ -1717,11 +1725,12 @@ PxeBcRegisterIp6Address (
     if (Ip6Addr == NULL) {
       return EFI_OUT_OF_RESOURCES;
     }
+
     Status = Ip6Cfg->GetData (
                        Ip6Cfg,
                        Ip6ConfigDataTypeManualAddress,
                        &DataSize,
-                       (VOID*) Ip6Addr
+                       (VOID *)Ip6Addr
                        );
     if (EFI_ERROR (Status)) {
       Status = EFI_DEVICE_ERROR;
@@ -1733,6 +1742,7 @@ PxeBcRegisterIp6Address (
         break;
       }
     }
+
     if (Index == DataSize / sizeof (EFI_IPv6_ADDRESS)) {
       Status = EFI_ABORTED;
       goto ON_EXIT;
@@ -1763,9 +1773,11 @@ ON_EXIT:
               );
     gBS->CloseEvent (MappedEvt);
   }
+
   if (Ip6Addr != NULL) {
     FreePool (Ip6Addr);
   }
+
   return Status;
 }
 
@@ -1780,16 +1792,16 @@ ON_EXIT:
 **/
 EFI_STATUS
 PxeBcSetIp6Policy (
-  IN PXEBC_PRIVATE_DATA            *Private
+  IN PXEBC_PRIVATE_DATA  *Private
   )
 {
-  EFI_IP6_CONFIG_POLICY            Policy;
-  EFI_STATUS                       Status;
-  EFI_IP6_CONFIG_PROTOCOL          *Ip6Cfg;
-  UINTN                            DataSize;
+  EFI_IP6_CONFIG_POLICY    Policy;
+  EFI_STATUS               Status;
+  EFI_IP6_CONFIG_PROTOCOL  *Ip6Cfg;
+  UINTN                    DataSize;
 
-  Ip6Cfg      = Private->Ip6Cfg;
-  DataSize    = sizeof (EFI_IP6_CONFIG_POLICY);
+  Ip6Cfg   = Private->Ip6Cfg;
+  DataSize = sizeof (EFI_IP6_CONFIG_POLICY);
 
   //
   // Get and store the current policy of IP6 driver.
@@ -1809,7 +1821,7 @@ PxeBcSetIp6Policy (
     Status = Ip6Cfg->SetData (
                        Ip6Cfg,
                        Ip6ConfigDataTypePolicy,
-                       sizeof(EFI_IP6_CONFIG_POLICY),
+                       sizeof (EFI_IP6_CONFIG_POLICY),
                        &Policy
                        );
     if (EFI_ERROR (Status)) {
@@ -1834,11 +1846,11 @@ PxeBcSetIp6Policy (
 **/
 EFI_STATUS
 PxeBcSetIp6Address (
-  IN  PXEBC_PRIVATE_DATA              *Private
+  IN  PXEBC_PRIVATE_DATA  *Private
   )
 {
-  EFI_STATUS                  Status;
-  EFI_DHCP6_PROTOCOL          *Dhcp6;
+  EFI_STATUS          Status;
+  EFI_DHCP6_PROTOCOL  *Dhcp6;
 
   Dhcp6 = Private->Dhcp6;
 
@@ -1885,47 +1897,48 @@ PxeBcSetIp6Address (
 EFI_STATUS
 EFIAPI
 PxeBcDhcp6CallBack (
-  IN  EFI_DHCP6_PROTOCOL           *This,
-  IN  VOID                         *Context,
-  IN  EFI_DHCP6_STATE              CurrentState,
-  IN  EFI_DHCP6_EVENT              Dhcp6Event,
-  IN  EFI_DHCP6_PACKET             *Packet,
-  OUT EFI_DHCP6_PACKET             **NewPacket     OPTIONAL
+  IN  EFI_DHCP6_PROTOCOL  *This,
+  IN  VOID                *Context,
+  IN  EFI_DHCP6_STATE     CurrentState,
+  IN  EFI_DHCP6_EVENT     Dhcp6Event,
+  IN  EFI_DHCP6_PACKET    *Packet,
+  OUT EFI_DHCP6_PACKET    **NewPacket     OPTIONAL
   )
 {
-  PXEBC_PRIVATE_DATA                  *Private;
-  EFI_PXE_BASE_CODE_MODE              *Mode;
-  EFI_PXE_BASE_CODE_CALLBACK_PROTOCOL *Callback;
-  EFI_DHCP6_PACKET                    *SelectAd;
-  EFI_STATUS                          Status;
-  BOOLEAN                             Received;
+  PXEBC_PRIVATE_DATA                   *Private;
+  EFI_PXE_BASE_CODE_MODE               *Mode;
+  EFI_PXE_BASE_CODE_CALLBACK_PROTOCOL  *Callback;
+  EFI_DHCP6_PACKET                     *SelectAd;
+  EFI_STATUS                           Status;
+  BOOLEAN                              Received;
 
   if ((Dhcp6Event != Dhcp6RcvdAdvertise) &&
       (Dhcp6Event != Dhcp6SelectAdvertise) &&
       (Dhcp6Event != Dhcp6SendSolicit) &&
       (Dhcp6Event != Dhcp6SendRequest) &&
-      (Dhcp6Event != Dhcp6RcvdReply)) {
+      (Dhcp6Event != Dhcp6RcvdReply))
+  {
     return EFI_SUCCESS;
   }
 
   ASSERT (Packet != NULL);
 
-  Private   = (PXEBC_PRIVATE_DATA *) Context;
-  Mode      = Private->PxeBc.Mode;
-  Callback  = Private->PxeBcCallback;
+  Private  = (PXEBC_PRIVATE_DATA *)Context;
+  Mode     = Private->PxeBc.Mode;
+  Callback = Private->PxeBcCallback;
 
   //
   // Callback to user when any traffic occurred if has.
   //
-  if (Dhcp6Event != Dhcp6SelectAdvertise && Callback != NULL) {
-    Received = (BOOLEAN) (Dhcp6Event == Dhcp6RcvdAdvertise || Dhcp6Event == Dhcp6RcvdReply);
-    Status = Callback->Callback (
-                         Callback,
-                         Private->Function,
-                         Received,
-                         Packet->Length,
-                         (EFI_PXE_BASE_CODE_PACKET *) &Packet->Dhcp6
-                         );
+  if ((Dhcp6Event != Dhcp6SelectAdvertise) && (Callback != NULL)) {
+    Received = (BOOLEAN)(Dhcp6Event == Dhcp6RcvdAdvertise || Dhcp6Event == Dhcp6RcvdReply);
+    Status   = Callback->Callback (
+                           Callback,
+                           Private->Function,
+                           Received,
+                           Packet->Length,
+                           (EFI_PXE_BASE_CODE_PACKET *)&Packet->Dhcp6
+                           );
     if (Status != EFI_PXE_BASE_CODE_CALLBACK_STATUS_CONTINUE) {
       return EFI_ABORTED;
     }
@@ -1934,108 +1947,114 @@ PxeBcDhcp6CallBack (
   Status = EFI_SUCCESS;
 
   switch (Dhcp6Event) {
+    case Dhcp6SendSolicit:
+      if (Packet->Length > PXEBC_DHCP6_PACKET_MAX_SIZE) {
+        //
+        // If the to be sent packet exceeds the maximum length, abort the DHCP process.
+        //
+        Status = EFI_ABORTED;
+        break;
+      }
 
-  case Dhcp6SendSolicit:
-    if (Packet->Length > PXEBC_DHCP6_PACKET_MAX_SIZE) {
       //
-      // If the to be sent packet exceeds the maximum length, abort the DHCP process.
+      // Record the first Solicate msg time
       //
-      Status = EFI_ABORTED;
-      break;
-    }
-
-    //
-    // Record the first Solicate msg time
-    //
-    if (Private->SolicitTimes == 0) {
-      CalcElapsedTime (Private);
-      Private->SolicitTimes++;
-    }
-    //
-    // Cache the dhcp discover packet to mode data directly.
-    //
-    CopyMem (&Mode->DhcpDiscover.Dhcpv4, &Packet->Dhcp6, Packet->Length);
-    break;
+      if (Private->SolicitTimes == 0) {
+        CalcElapsedTime (Private);
+        Private->SolicitTimes++;
+      }
 
-  case Dhcp6RcvdAdvertise:
-    Status = EFI_NOT_READY;
-    if (Packet->Length > PXEBC_DHCP6_PACKET_MAX_SIZE) {
       //
-      // Ignore the incoming packets which exceed the maximum length.
+      // Cache the dhcp discover packet to mode data directly.
       //
+      CopyMem (&Mode->DhcpDiscover.Dhcpv4, &Packet->Dhcp6, Packet->Length);
       break;
-    }
-    if (Private->OfferNum < PXEBC_OFFER_MAX_NUM) {
+
+    case Dhcp6RcvdAdvertise:
+      Status = EFI_NOT_READY;
+      if (Packet->Length > PXEBC_DHCP6_PACKET_MAX_SIZE) {
+        //
+        // Ignore the incoming packets which exceed the maximum length.
+        //
+        break;
+      }
+
+      if (Private->OfferNum < PXEBC_OFFER_MAX_NUM) {
+        //
+        // Cache the dhcp offers to OfferBuffer[] for select later, and record
+        // the OfferIndex and OfferCount.
+        //
+        PxeBcCacheDhcp6Offer (Private, Packet);
+      }
+
+      break;
+
+    case Dhcp6SendRequest:
+      if (Packet->Length > PXEBC_DHCP6_PACKET_MAX_SIZE) {
+        //
+        // If the to be sent packet exceeds the maximum length, abort the DHCP process.
+        //
+        Status = EFI_ABORTED;
+        break;
+      }
+
       //
-      // Cache the dhcp offers to OfferBuffer[] for select later, and record
-      // the OfferIndex and OfferCount.
+      // Store the request packet as seed packet for discover.
       //
-      PxeBcCacheDhcp6Offer (Private, Packet);
-    }
-    break;
+      if (Private->Dhcp6Request != NULL) {
+        FreePool (Private->Dhcp6Request);
+      }
+
+      Private->Dhcp6Request = AllocateZeroPool (Packet->Size);
+      if (Private->Dhcp6Request != NULL) {
+        CopyMem (Private->Dhcp6Request, Packet, Packet->Size);
+      }
+
+      break;
 
-  case Dhcp6SendRequest:
-    if (Packet->Length > PXEBC_DHCP6_PACKET_MAX_SIZE) {
+    case Dhcp6SelectAdvertise:
       //
-      // If the to be sent packet exceeds the maximum length, abort the DHCP process.
+      // Select offer by the default policy or by order, and record the SelectIndex
+      // and SelectProxyType.
       //
-      Status = EFI_ABORTED;
-      break;
-    }
+      PxeBcSelectDhcp6Offer (Private);
 
-    //
-    // Store the request packet as seed packet for discover.
-    //
-    if (Private->Dhcp6Request != NULL) {
-      FreePool (Private->Dhcp6Request);
-    }
-    Private->Dhcp6Request = AllocateZeroPool (Packet->Size);
-    if (Private->Dhcp6Request != NULL) {
-      CopyMem (Private->Dhcp6Request, Packet, Packet->Size);
-    }
-    break;
+      if (Private->SelectIndex == 0) {
+        Status = EFI_ABORTED;
+      } else {
+        ASSERT (NewPacket != NULL);
+        SelectAd   = &Private->OfferBuffer[Private->SelectIndex - 1].Dhcp6.Packet.Offer;
+        *NewPacket = AllocateZeroPool (SelectAd->Size);
+        ASSERT (*NewPacket != NULL);
+        if (*NewPacket == NULL) {
+          return EFI_ABORTED;
+        }
 
-  case Dhcp6SelectAdvertise:
-    //
-    // Select offer by the default policy or by order, and record the SelectIndex
-    // and SelectProxyType.
-    //
-    PxeBcSelectDhcp6Offer (Private);
+        CopyMem (*NewPacket, SelectAd, SelectAd->Size);
+      }
 
-    if (Private->SelectIndex == 0) {
-      Status = EFI_ABORTED;
-    } else {
-      ASSERT (NewPacket != NULL);
-      SelectAd   = &Private->OfferBuffer[Private->SelectIndex - 1].Dhcp6.Packet.Offer;
-      *NewPacket = AllocateZeroPool (SelectAd->Size);
-      ASSERT (*NewPacket != NULL);
-      if (*NewPacket == NULL) {
-        return EFI_ABORTED;
+      break;
+
+    case Dhcp6RcvdReply:
+      //
+      // Cache the dhcp ack to Private->Dhcp6Ack, but it's not the final ack in mode data
+      // without verification.
+      //
+      ASSERT (Private->SelectIndex != 0);
+      Status = PxeBcCopyDhcp6Ack (Private, Packet, FALSE);
+      if (EFI_ERROR (Status)) {
+        Status = EFI_ABORTED;
       }
-      CopyMem (*NewPacket, SelectAd, SelectAd->Size);
-    }
-    break;
 
-  case Dhcp6RcvdReply:
-    //
-    // Cache the dhcp ack to Private->Dhcp6Ack, but it's not the final ack in mode data
-    // without verification.
-    //
-    ASSERT (Private->SelectIndex != 0);
-    Status = PxeBcCopyDhcp6Ack (Private, Packet, FALSE);
-    if (EFI_ERROR (Status)) {
-      Status = EFI_ABORTED;
-    }
-    break;
+      break;
 
-  default:
-    ASSERT (0);
+    default:
+      ASSERT (0);
   }
 
   return Status;
 }
 
-
 /**
   Build and send out the request packet for the bootfile, and parse the reply.
 
@@ -2053,37 +2072,37 @@ PxeBcDhcp6CallBack (
 **/
 EFI_STATUS
 PxeBcDhcp6Discover (
-  IN  PXEBC_PRIVATE_DATA              *Private,
-  IN  UINT16                          Type,
-  IN  UINT16                          *Layer,
-  IN  BOOLEAN                         UseBis,
-  IN  EFI_IP_ADDRESS                  *DestIp
+  IN  PXEBC_PRIVATE_DATA  *Private,
+  IN  UINT16              Type,
+  IN  UINT16              *Layer,
+  IN  BOOLEAN             UseBis,
+  IN  EFI_IP_ADDRESS      *DestIp
   )
 {
-  EFI_PXE_BASE_CODE_UDP_PORT          SrcPort;
-  EFI_PXE_BASE_CODE_UDP_PORT          DestPort;
-  EFI_PXE_BASE_CODE_MODE              *Mode;
-  EFI_PXE_BASE_CODE_PROTOCOL          *PxeBc;
-  EFI_PXE_BASE_CODE_DHCPV6_PACKET     *Discover;
-  UINTN                               DiscoverLen;
-  EFI_DHCP6_PACKET                    *Request;
-  UINTN                               RequestLen;
-  EFI_DHCP6_PACKET                    *Reply;
-  UINT8                               *RequestOpt;
-  UINT8                               *DiscoverOpt;
-  UINTN                               ReadSize;
-  UINT16                              OpCode;
-  UINT16                              OpLen;
-  UINT32                              Xid;
-  EFI_STATUS                          Status;
-
-  PxeBc       = &Private->PxeBc;
-  Mode        = PxeBc->Mode;
-  Request     = Private->Dhcp6Request;
-  SrcPort     = PXEBC_BS_DISCOVER_PORT;
-  DestPort    = PXEBC_BS_DISCOVER_PORT;
-
-  if (!UseBis && Layer != NULL) {
+  EFI_PXE_BASE_CODE_UDP_PORT       SrcPort;
+  EFI_PXE_BASE_CODE_UDP_PORT       DestPort;
+  EFI_PXE_BASE_CODE_MODE           *Mode;
+  EFI_PXE_BASE_CODE_PROTOCOL       *PxeBc;
+  EFI_PXE_BASE_CODE_DHCPV6_PACKET  *Discover;
+  UINTN                            DiscoverLen;
+  EFI_DHCP6_PACKET                 *Request;
+  UINTN                            RequestLen;
+  EFI_DHCP6_PACKET                 *Reply;
+  UINT8                            *RequestOpt;
+  UINT8                            *DiscoverOpt;
+  UINTN                            ReadSize;
+  UINT16                           OpCode;
+  UINT16                           OpLen;
+  UINT32                           Xid;
+  EFI_STATUS                       Status;
+
+  PxeBc    = &Private->PxeBc;
+  Mode     = PxeBc->Mode;
+  Request  = Private->Dhcp6Request;
+  SrcPort  = PXEBC_BS_DISCOVER_PORT;
+  DestPort = PXEBC_BS_DISCOVER_PORT;
+
+  if (!UseBis && (Layer != NULL)) {
     *Layer &= EFI_PXE_BASE_CODE_BOOT_LAYER_MASK;
   }
 
@@ -2108,10 +2127,11 @@ PxeBcDhcp6Discover (
   RequestLen              = DiscoverLen;
 
   while (RequestLen < Request->Length) {
-    OpCode = NTOHS (((EFI_DHCP6_PACKET_OPTION *) RequestOpt)->OpCode);
-    OpLen  = NTOHS (((EFI_DHCP6_PACKET_OPTION *) RequestOpt)->OpLen);
-    if (OpCode != EFI_DHCP6_IA_TYPE_NA &&
-        OpCode != EFI_DHCP6_IA_TYPE_TA) {
+    OpCode = NTOHS (((EFI_DHCP6_PACKET_OPTION *)RequestOpt)->OpCode);
+    OpLen  = NTOHS (((EFI_DHCP6_PACKET_OPTION *)RequestOpt)->OpLen);
+    if ((OpCode != EFI_DHCP6_IA_TYPE_NA) &&
+        (OpCode != EFI_DHCP6_IA_TYPE_TA))
+    {
       //
       // Copy all the options except IA option.
       //
@@ -2119,6 +2139,7 @@ PxeBcDhcp6Discover (
       DiscoverOpt += (OpLen + 4);
       DiscoverLen += (OpLen + 4);
     }
+
     RequestOpt += (OpLen + 4);
     RequestLen += (OpLen + 4);
   }
@@ -2134,7 +2155,7 @@ PxeBcDhcp6Discover (
                     NULL,
                     NULL,
                     &DiscoverLen,
-                    (VOID *) Discover
+                    (VOID *)Discover
                     );
   if (EFI_ERROR (Status)) {
     goto ON_ERROR;
@@ -2150,7 +2171,8 @@ PxeBcDhcp6Discover (
   } else {
     Reply = &Private->ProxyOffer.Dhcp6.Packet.Offer;
   }
-  ReadSize = (UINTN) Reply->Size;
+
+  ReadSize = (UINTN)Reply->Size;
 
   //
   // Start Udp6Read instance
@@ -2170,7 +2192,7 @@ PxeBcDhcp6Discover (
                     NULL,
                     NULL,
                     &ReadSize,
-                    (VOID *) &Reply->Dhcp6
+                    (VOID *)&Reply->Dhcp6
                     );
   //
   // Stop Udp6Read instance
@@ -2190,7 +2212,6 @@ ON_ERROR:
   return Status;
 }
 
-
 /**
   Start the DHCPv6 S.A.R.R. process to acquire the IPv6 address and other PXE boot information.
 
@@ -2203,35 +2224,35 @@ ON_ERROR:
 **/
 EFI_STATUS
 PxeBcDhcp6Sarr (
-  IN PXEBC_PRIVATE_DATA            *Private,
-  IN EFI_DHCP6_PROTOCOL            *Dhcp6
+  IN PXEBC_PRIVATE_DATA  *Private,
+  IN EFI_DHCP6_PROTOCOL  *Dhcp6
   )
 {
-  EFI_PXE_BASE_CODE_MODE           *PxeMode;
-  EFI_DHCP6_CONFIG_DATA            Config;
-  EFI_DHCP6_MODE_DATA              Mode;
-  EFI_DHCP6_RETRANSMISSION         *Retransmit;
-  EFI_DHCP6_PACKET_OPTION          *OptList[PXEBC_DHCP6_OPTION_MAX_NUM];
-  UINT8                            Buffer[PXEBC_DHCP6_OPTION_MAX_SIZE];
-  UINT32                           OptCount;
-  EFI_STATUS                       Status;
-  EFI_IP6_CONFIG_PROTOCOL          *Ip6Cfg;
-  EFI_STATUS                       TimerStatus;
-  EFI_EVENT                        Timer;
-  UINT64                           GetMappingTimeOut;
-  UINTN                            DataSize;
-  EFI_IP6_CONFIG_DUP_ADDR_DETECT_TRANSMITS    DadXmits;
-
-  Status     = EFI_SUCCESS;
-  PxeMode    = Private->PxeBc.Mode;
-  Ip6Cfg     = Private->Ip6Cfg;
-  Timer      = NULL;
+  EFI_PXE_BASE_CODE_MODE                    *PxeMode;
+  EFI_DHCP6_CONFIG_DATA                     Config;
+  EFI_DHCP6_MODE_DATA                       Mode;
+  EFI_DHCP6_RETRANSMISSION                  *Retransmit;
+  EFI_DHCP6_PACKET_OPTION                   *OptList[PXEBC_DHCP6_OPTION_MAX_NUM];
+  UINT8                                     Buffer[PXEBC_DHCP6_OPTION_MAX_SIZE];
+  UINT32                                    OptCount;
+  EFI_STATUS                                Status;
+  EFI_IP6_CONFIG_PROTOCOL                   *Ip6Cfg;
+  EFI_STATUS                                TimerStatus;
+  EFI_EVENT                                 Timer;
+  UINT64                                    GetMappingTimeOut;
+  UINTN                                     DataSize;
+  EFI_IP6_CONFIG_DUP_ADDR_DETECT_TRANSMITS  DadXmits;
+
+  Status  = EFI_SUCCESS;
+  PxeMode = Private->PxeBc.Mode;
+  Ip6Cfg  = Private->Ip6Cfg;
+  Timer   = NULL;
 
   //
   // Build option list for the request packet.
   //
-  OptCount   = PxeBcBuildDhcp6Options (Private, OptList, Buffer);
-  ASSERT (OptCount> 0);
+  OptCount = PxeBcBuildDhcp6Options (Private, OptList, Buffer);
+  ASSERT (OptCount > 0);
 
   Retransmit = AllocateZeroPool (sizeof (EFI_DHCP6_RETRANSMISSION));
   if (Retransmit == NULL) {
@@ -2274,7 +2295,6 @@ PxeBcDhcp6Sarr (
   ZeroMem (Private->OfferCount, sizeof (Private->OfferCount));
   ZeroMem (Private->OfferIndex, sizeof (Private->OfferIndex));
 
-
   //
   // Start DHCPv6 S.A.R.R. process to acquire IPv6 address.
   //
@@ -2290,12 +2310,12 @@ PxeBcDhcp6Sarr (
     // Get Duplicate Address Detection Transmits count.
     //
     DataSize = sizeof (EFI_IP6_CONFIG_DUP_ADDR_DETECT_TRANSMITS);
-    Status = Ip6Cfg->GetData (
-                       Ip6Cfg,
-                       Ip6ConfigDataTypeDupAddrDetectTransmits,
-                       &DataSize,
-                       &DadXmits
-                       );
+    Status   = Ip6Cfg->GetData (
+                         Ip6Cfg,
+                         Ip6ConfigDataTypeDupAddrDetectTransmits,
+                         &DataSize,
+                         &DadXmits
+                         );
     if (EFI_ERROR (Status)) {
       Dhcp6->Configure (Dhcp6, NULL);
       return Status;
@@ -2308,7 +2328,7 @@ PxeBcDhcp6Sarr (
     }
 
     GetMappingTimeOut = TICKS_PER_SECOND * DadXmits.DupAddrDetectTransmits + PXEBC_DAD_ADDITIONAL_DELAY;
-    Status = gBS->SetTimer (Timer, TimerRelative, GetMappingTimeOut);
+    Status            = gBS->SetTimer (Timer, TimerRelative, GetMappingTimeOut);
     if (EFI_ERROR (Status)) {
       gBS->CloseEvent (Timer);
       Dhcp6->Configure (Dhcp6, NULL);
@@ -2316,7 +2336,6 @@ PxeBcDhcp6Sarr (
     }
 
     do {
-
       TimerStatus = gBS->CheckEvent (Timer);
       if (!EFI_ERROR (TimerStatus)) {
         Status = Dhcp6->Start (Dhcp6);
@@ -2325,10 +2344,12 @@ PxeBcDhcp6Sarr (
 
     gBS->CloseEvent (Timer);
   }
+
   if (EFI_ERROR (Status)) {
     if (Status == EFI_ICMP_ERROR) {
       PxeMode->IcmpErrorReceived = TRUE;
     }
+
     Dhcp6->Configure (Dhcp6, NULL);
     return Status;
   }
